<template>
  <div>
    <b-container fluid>
      <b-row>
        <b-col>
          <b-form-select
            v-model="selectedRooms"
            class="mr-2"
            :options="roomOptions"
            multiple
            @change="refresh"
          ></b-form-select>
        </b-col>
        <b-col>
          <b-button-toolbar justify class="float-right">
            <b-button-group>
              <b-button
                :variant="heatmap ? 'success' : 'outline-secondary'"
                @click="heatmap = !heatmap"
                >Toggle heatmap</b-button
              >
              <b-button variant="outline-primary" @click="refresh"
                ><b-icon icon="arrow-clockwise" aria-hidden="true"></b-icon
              ></b-button>
            </b-button-group>
          </b-button-toolbar>
        </b-col>
      </b-row>
    </b-container>

    <br />

    <div v-for="room in selectedRooms" :key="room.id">
      <h6>{{ room.name }}</h6>
      <div :id="room.slug" v-if="workstations[room.id]">
        <div v-if="room.map !== ''">
          <div v-html="room.map"></div>
        </div>

        <div v-if="room.map === ''">
          <b-table :fields="tableFields" :items="tableItems(room)">
            <template #cell(current_users)="row">
              <ul v-if="typeof row.value !== 'string'">
                <li v-for="sessionState in row.value" :key="sessionState.id">
                  <b-link
                    :href="`https://cri.epita.fr/users/${sessionState.login}`"
                    target="_blank"
                    >{{ sessionState.login }}
                    <div v-if="sessionState.locked">(locked)</div>
                    <b-img-lazy
                      :src="`https://photos.cri.epita.fr/square/${sessionState.login}`"
                      width="70%"
                    ></b-img-lazy>
                  </b-link>
                </li>
              </ul>
              <p v-else>{{ row.value }}</p>
            </template>

            <template #cell(details)="row">
              <b-button :id="row.value">Details</b-button>
            </template>
          </b-table>
        </div>
      </div>
      <br />
    </div>

    <div v-for="room in selectedRooms" :key="room.id">
      <b-popover
        v-for="workstation in workstations[room.id]"
        :key="workstation.id"
        :target="workstation.fqdn"
        :triggers="['click', 'hover']"
        placement="top"
        :title="workstation.name"
        variant="dark"
      >
        IP: {{ workstation.ip }} <br />

        Switch: {{ workstation.switch_name }}:{{ workstation.switch_port }}
        <br />

        <div v-if="workstation.machine">
          MAC: {{ workstation.machine.mac }} <br />
        </div>
        <div v-else>No machine registered for this workstation. <br /></div>

        <div
          v-if="
            workstation.ip in sessionStates &&
            sessionStates[workstation.ip].length !== 0
          "
        >
          Image: {{ sessionStates[workstation.ip][0].image }}<br />
          Currently connected:
          <ul>
            <li
              v-for="sessionState in sessionStates[workstation.ip].filter(
                (sessionState) => 'login' in sessionState
              )"
              :key="sessionState.id"
            >
              <b-link
                :href="`https://cri.epita.fr/users/${sessionState.login}`"
                target="_blank"
                >{{ sessionState.login }}
                <div v-if="sessionState.locked">(locked)</div>
                <b-img-lazy
                  :src="`https://photos.cri.epita.fr/square/${sessionState.login}`"
                  width="70%"
                ></b-img-lazy>
              </b-link>
            </li>
          </ul>
        </div>
        <div v-else>No one connected.<br /></div>
        <b-button
          pill
          class="float-right"
          variant="outline-primary"
          size="sm"
          @click="
            workstationId = workstation.id
            submitIssueForm.workstationUrl = workstation.url
            $bvModal.show('modal-issue-submit')
          "
          >Submit issue</b-button
        >
        <div v-if="workstation.issues.length !== 0">
          Issues:
          <ul>
            <li v-for="issue in workstation.issues" :key="issue.id">
              Type: {{ issue.problem_type }}<br />
              Severity: {{ issue.severity }}<br />
              Status: {{ issue.status }}<br />
              Description:<br />{{ issue.description }}<br />
              <b-button
                v-if="issue.status === 'new'"
                pill
                variant="outline-primary"
                size="sm"
                @click="
                  workstationId = workstation.id
                  issueId = issue.id
                  handleConfirmIssue()
                "
                >Confirm</b-button
              >
              <b-button
                v-if="issue.status === 'new'"
                pill
                variant="outline-danger"
                size="sm"
                @click="
                  workstationId = workstation.id
                  issueId = issue.id
                  handleRejectIssue()
                "
                >Reject</b-button
              >
              <b-button
                v-if="issue.status === 'confirmed'"
                pill
                variant="outline-success"
                size="sm"
                @click="
                  workstationId = workstation.id
                  issueId = issue.id
                  handleResolveIssue()
                "
                >Resolve</b-button
              >
            </li>
          </ul>
        </div>
        <div v-else>No issues reported.</div>
      </b-popover>
    </div>

    <b-modal
      id="modal-issue-submit"
      ref="model-issue-submit"
      title="Submit an issue"
      @ok="handleModelIssueSubmitOk"
    >
      <b-form
        ref="formIssueSubmit"
        @submit.stop.prevent="handleFormIssueSubmitSubmit"
      >
        <b-form-group
          id="form-issue-submit-description-group"
          label="Description"
          label-for="form-issue-submit-description"
        >
          <b-form-textarea
            id="form-issue-submit-description"
            v-model="submitIssueForm.description"
            placeholder="Enter a detailed description of the problem."
            required
            :state="submitIssueForm.description.length >= 8"
          ></b-form-textarea>
        </b-form-group>

        <b-form-group
          id="form-issue-submit-problem-type-group"
          label="Problem type"
          label-for="form-issue-submit-problem-type"
        >
          <b-form-select
            id="form-issue-submit-problem-type"
            v-model="submitIssueForm.problemType"
            :options="submitIssueFormProblemTypeOptions"
          ></b-form-select>
        </b-form-group>

        <b-form-group
          id="form-issue-submit-severity-group"
          label="Severity"
          label-for="form-issue-submit-severity"
        >
          <b-form-select
            id="form-issue-submit-severity"
            v-model="submitIssueForm.severity"
            :options="submitIssueFormSeverityOptions"
          ></b-form-select>
        </b-form-group>
      </b-form>
    </b-modal>

    <b-card>
      <b-table-lite :items="[stats]"></b-table-lite>
    </b-card>
  </div>
</template>

<script>
import * as errors from '~/utils/errors.js'
import * as toast from '~/utils/toast.js'

export default {
  middleware: ['auth'],
  data() {
    return {
      selectedRooms: [],
      heatmap: false,
      submitIssueForm: {
        workstationUrl: null,
        description: '',
        problemType: 'unknown',
        severity: 'unknown',
      },
      issueId: null,
      workstationId: null,
      submitIssueFormProblemTypeOptions: [
        { value: 'unknown', text: 'Unknown' },
        { value: 'machine', text: 'Machine' },
        { value: 'keyboard', text: 'Keyboard' },
        { value: 'mouse', text: 'Mouse' },
        { value: 'screen', text: 'Screen' },
        { value: 'video_cable', text: 'Video cable' },
        { value: 'power', text: 'Power' },
        { value: 'network', text: 'Network' },
        { value: 'link', text: 'Network cable' },
        { value: 'table', text: 'Table' },
        { value: 'vesa', text: 'VESA mount' },
      ],
      submitIssueFormSeverityOptions: [
        { value: 'unknown', text: 'Unknown' },
        { value: 'low', text: 'Low' },
        { value: 'medium', text: 'Medium' },
        { value: 'high', text: 'High' },
      ],
    }
  },
  computed: {
    sites() {
      return this.$store.getters['fleet/sites']
    },
    rooms() {
      return this.$store.getters['fleet/roomsBySite']
    },
    roomOptions() {
      return Object.keys(this.rooms).map((siteId) => {
        if (!(siteId in this.sites)) {
          return {}
        }

        return {
          label: this.sites[siteId].name,
          options: Object.values(this.rooms[siteId]).map((room) => {
            return {
              value: room,
              text: room.name,
            }
          }),
        }
      })
    },
    workstations() {
      return this.$store.getters['fleet/workstationsByRoom']
    },
    sessionStates() {
      return this.$store.getters['sessions_state/sessionStatesByIP']
    },
    sessionStats() {
      return this.$store.getters['sessions_state/sessionStats']
    },
    stats() {
      let connectedUsers = 0
      let lockedUsers = 0
      let unusedMachines = 0

      this.selectedRooms.forEach((room) => {
        if (!(room.id in this.workstations)) {
          return
        }

        this.workstations[room.id].forEach((workstation) => {
          if (
            workstation.ip in this.sessionStates &&
            this.sessionStates[workstation.ip].length !== 0
          ) {
            // At least one person is connected
            connectedUsers += 1
            if (
              this.sessionStates[workstation.ip].some(
                (sessionState) =>
                  'locked' in sessionState && sessionState.locked
              )
            ) {
              // At least one person is locked
              lockedUsers += 1
            }
          } else {
            // No one is connected
            unusedMachines += 1
          }
        })
      })

      return {
        connectedUsers,
        lockedUsers,
        unusedMachines,
      }
    },
    tableFields() {
      return [
        {
          key: 'name',
          label: 'Name',
          sortable: true,
        },
        {
          key: 'ip',
          label: 'IP',
          sortable: true,
        },
        {
          key: 'switch',
          label: 'Switch',
          sortable: true,
        },
        {
          key: 'mac',
          label: 'MAC',
          sortable: true,
        },
        {
          key: 'image',
          label: 'Image',
          sortable: true,
        },
        {
          key: 'current_users',
          label: 'Current users',
        },
        {
          key: 'details',
          label: 'Details',
        },
      ]
    },
    tableItems() {
      return (room) => {
        if (!(room.id in this.workstations)) {
          return []
        }

        return this.workstations[room.id].map((workstation) => {
          const item = {
            name: workstation.name,
            ip: workstation.ip,
            switch: `${workstation.switch_name}:${workstation.switch_port}`,
            mac: workstation.machine ? workstation.machine.mac : '',
            details: workstation.fqdn,
          }
          if (
            workstation.ip in this.sessionStates &&
            this.sessionStates[workstation.ip].length !== 0
          ) {
            item.image = this.sessionStates[workstation.ip][0].image
            item.current_users = this.sessionStates[workstation.ip]
          } else {
            item.current_users = 'No one connected.'
          }
          return item
        })
      }
    },
  },
  watch: {
    heatmap: function handle(val, oldVal) {
      this.renderRect()
    },
  },
  created() {
    this.refresh(null)
  },
  updated() {
    this.$nextTick(function () {
      this.renderRect()
    })
  },
  methods: {
    refresh(event) {
      this.$store.commit('sessions_state/clearSessionStates')
      this.$store.dispatch('fleet/getSites').catch(errors.handleError(this))
      this.$store.dispatch('fleet/getRooms').catch(errors.handleError(this))

      this.selectedRooms.forEach((room) => {
        this.$store
          .dispatch('fleet/getWorkstationsByRoom', room.id)
          .catch(errors.handleError(this))
        // We want this to fail silently
        this.$store.dispatch(
          'sessions_state/getSessionStatesByRoomCurrentLatest',
          room.id
        )
        this.$store
          .dispatch('sessions_state/getSessionStatsByRoom', room.id)
          .catch(errors.handleError(this))
      })
    },
    getRectangle(workstation) {
      return document.getElementById(workstation.fqdn)
    },
    renderCurrentUsage() {
      this.selectedRooms.forEach((room) => {
        if (room.map === '') {
          return
        }
        if (!(room.id in this.workstations)) {
          return
        }

        this.workstations[room.id].forEach((workstation) => {
          const rect = this.getRectangle(workstation)
          if (rect === null) {
            return
          }

          let fill = 'none'
          if (
            this.sessionStates[workstation.ip] &&
            this.sessionStates[workstation.ip].length !== 0
          ) {
            // At least one person is connected
            if (
              this.sessionStates[workstation.ip].some(
                (sessionState) =>
                  'locked' in sessionState && sessionState.locked
              )
            ) {
              // At least one person is locked
              fill = '#ffffff'
            } else {
              fill = '#007bff'
            }
          } else if (
            workstation.issues.some(
              (issue) =>
                issue.severity === 'medium' || issue.severity === 'high'
            )
          ) {
            fill = '#ffff00'
          } else {
            fill = '#28a745'
          }
          rect.style.fill = fill
        })
      })
    },
    renderHeatmap() {
      if (!this.sessionStats) {
        return
      }

      const sessionStats = Object.keys(this.sessionStats)
        .filter((ip) =>
          this.selectedRooms.some((room) =>
            this.workstations[room.id].some(
              (workstation) => workstation.ip === ip
            )
          )
        )
        .reduce((obj, ip) => {
          obj[ip] = this.sessionStats[ip]
          return obj
        }, {})

      const maxDuration = Math.max(...Object.values(sessionStats))

      this.selectedRooms.forEach((room) => {
        if (room.map === '') {
          return
        }
        if (!(room.id in this.workstations)) {
          return
        }

        this.workstations[room.id].forEach((workstation) => {
          const rect = this.getRectangle(workstation)
          if (rect === null) {
            return
          }

          let fill = 'none'

          if (workstation.ip in sessionStats) {
            const rate = sessionStats[workstation.ip] / maxDuration
            fill = `rgba(0, 128, 0, ${rate})`
          }

          rect.style.fill = fill
        })
      })
    },
    renderRect() {
      if (!this.heatmap) {
        this.renderCurrentUsage()
      } else {
        this.renderHeatmap()
      }
    },
    handleModelIssueSubmitOk(event) {
      event.preventDefault()
      this.handleFormIssueSubmitSubmit()
    },
    checkFormIssueSubmitValidity() {
      return this.$refs.formIssueSubmit.checkValidity()
    },
    handleFormIssueSubmitSubmit() {
      if (!this.checkFormIssueSubmitValidity()) {
        return
      }
      toast.toast(
        this,
        'Submitting issue',
        'Please wait a few seconds...',
        'info'
      )

      this.$store
        .dispatch('fleet/submitIssue', this.submitIssueForm)
        .then(() => {
          this.$store.dispatch('fleet/getWorkstation', this.workstationId)
          this.$nextTick(() => {
            this.$bvModal.hide('modal-issue-submit')
          })
          toast.toast(this, 'Issue has been submitted', 'Thank you!', 'success')
        })
        .catch(errors.handleError(this))
    },
    handleConfirmIssue() {
      toast.toast(
        this,
        'Confirming issue',
        'Please wait a few seconds...',
        'info'
      )

      this.$store
        .dispatch('fleet/confirmIssue', this.issueId)
        .then(() => {
          this.$store.dispatch('fleet/getWorkstation', this.workstationId)
          toast.toast(this, 'Issue has been confirmed', 'Thank you!', 'success')
        })
        .catch(errors.handleError(this))
    },
    handleRejectIssue() {
      toast.toast(
        this,
        'Rejecting issue',
        'Please wait a few seconds...',
        'info'
      )

      this.$store
        .dispatch('fleet/rejectIssue', this.issueId)
        .then(() => {
          this.$store.dispatch('fleet/getWorkstation', this.workstationId)
          toast.toast(this, 'Issue has been rejected', 'Thank you!', 'success')
        })
        .catch(errors.handleError(this))
    },
    handleResolveIssue() {
      toast.toast(
        this,
        'Resolving issue',
        'Please wait a few seconds...',
        'info'
      )

      this.$store
        .dispatch('fleet/resolveIssue', this.issueId)
        .then(() => {
          this.$store.dispatch('fleet/getWorkstation', this.workstationId)
          toast.toast(this, 'Issue has been resolved', 'Nice job!', 'success')
        })
        .catch(errors.handleError(this))
    },
  },
}
</script>
